<?php

/**
 * Show ENVironment INFO result from Admin Menu
 *
 * @module          env_info 
 * @author          Wolfgang Studer
 * @copyright       2014 Wolfgang Studer
 * @link            http://www.LEPTON-cms.org
 * @license         BSD License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1 2014-11-17
 */ 

// include class.secure.php to protect this file and the whole CMS!
if (defined('WB_PATH')) {	
	include(WB_PATH.'/framework/class.secure.php'); 
} else {
	$oneback = "../";
	$root = $oneback;
	$level = 1;
	while (($level < 10) && (!file_exists($root.'/framework/class.secure.php'))) {
		$root .= $oneback;
		$level += 1;
	}
	if (file_exists($root.'/framework/class.secure.php')) { 
		include($root.'/framework/class.secure.php'); 
	} else {
		trigger_error(sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR);
	}
}
// end include class.secure.php

/**
 *
 * AddOn: return CMS modules info
 *
 */

// function return result array
function getCMS_MODULE()
{
	global $database;
	
	// define the array
	$envinfoArray = Array();
	
	$table_modules = TABLE_PREFIX . "addons";

	$query = "SELECT a.type, a.function, a.directory, a.name, a.description, a.version, a.guid, a.platform, a.author, a.license
			FROM " . $table_modules . " a 
			ORDER BY a.type, a.function, a.name ASC";
		
	if ( $query_data = $database->query( $query) ):
		while ( $result = $query_data->fetchRow() ):

			if ( empty( $result['function']) == TRUE ):
				 $result['function'] =  $result['type'];
			endif;

			$envinfoArray[ $result['type'] ][ $result['function'] ][ $result['name'] ]['type'] 			=  $result['type'];
			$envinfoArray[ $result['type'] ][ $result['function'] ][ $result['name'] ]['function'] 		=  $result['function'];
			$envinfoArray[ $result['type'] ][ $result['function'] ][ $result['name'] ]['directory'] 	=  $result['directory'];
			$envinfoArray[ $result['type'] ][ $result['function'] ][ $result['name'] ]['name'] 			=  $result['name'];
			$envinfoArray[ $result['type'] ][ $result['function'] ][ $result['name'] ]['description'] 	=  $result['description'];
			$envinfoArray[ $result['type'] ][ $result['function'] ][ $result['name'] ]['version'] 		=  $result['version'];
			$envinfoArray[ $result['type'] ][ $result['function'] ][ $result['name'] ]['guid'] 			=  $result['guid'];
			$envinfoArray[ $result['type'] ][ $result['function'] ][ $result['name'] ]['platform'] 		=  $result['platform'];
			$envinfoArray[ $result['type'] ][ $result['function'] ][ $result['name'] ]['author'] 		=  $result['author'];
			$envinfoArray[ $result['type'] ][ $result['function'] ][ $result['name'] ]['license'] 		=  $result['license'];
			
		endwhile;
	endif;

	// return the array
	return $envinfoArray;
}

// return the select option
	$infoItems["getCMS_MODULE"] = "CMS_MODULE";
	
// Add translation
	switch ( LANGUAGE):
	case "DE":
			$ENVINFOTEXT['CMS_MODULE'] = "CMS Module - Infos ber installierte CMS Module.";
			break;
	default:
			$ENVINFOTEXT['CMS_MODULE'] = "CMS Module - Informations about installed CMS Modules.";
	
	endswitch;

?>
