<?php

/**
 * Show ENVironment INFO result from Admin Menu
 *
 * @module          env_info 
 * @author          Wolfgang Studer
 * @copyright       2014 Wolfgang Studer
 * @link            http://www.LEPTON-cms.org
 * @license         BSD License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1 2014-11-17
 */ 

// include class.secure.php to protect this file and the whole CMS!
if (defined('WB_PATH')) {	
	include(WB_PATH.'/framework/class.secure.php'); 
} else {
	$oneback = "../";
	$root = $oneback;
	$level = 1;
	while (($level < 10) && (!file_exists($root.'/framework/class.secure.php'))) {
		$root .= $oneback;
		$level += 1;
	}
	if (file_exists($root.'/framework/class.secure.php')) { 
		include($root.'/framework/class.secure.php'); 
	} else {
		trigger_error(sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR);
	}
}
// end include class.secure.php

/**
 *
 * AddOn: return DB connection details
 *
 */

// function return result array
function getDB_CONNECTION()
{
	global $database;
	
	// define the array
	$envinfoArray = Array();
	
	// get PDO attributes
	$DBhandler = $database->get_db_handle();
	$attributes = Array( "AUTOCOMMIT", "ERRMODE", "CASE", "CLIENT_VERSION", "CONNECTION_STATUS", "PERSISTENT", "PREFETCH", "SERVER_INFO","SERVER_VERSION", "TIMEOUT" );

	$envinfoArray['DB Connection'] = Array();
	foreach ($attributes as $attr):

		try {
			// database connection
			$envinfoArray['DB Connection']["PDO::ATTR_" . $attr ] = $DBhandler->getAttribute(constant("PDO::ATTR_" . $attr ));
		}
		catch(PDOException $pe) {
			$envinfoArray['DB Connection']["PDO::ATTR_" . $attr ] = "-- n.a. --";
		}
	endforeach;

	// return the array
	return $envinfoArray;
}

// return the select option
	$infoItems["getDB_CONNECTION"] = "DB_CONNECTION";
	
// Add translation
	switch ( LANGUAGE):
	case "DE":
			$ENVINFOTEXT['DB_CONNECTION'] = "DB Connection - Details zur Datenbank Verbindung.";
			break;
	default:
			$ENVINFOTEXT['DB_CONNECTION'] = "DB Connection - Show database connection details.";
	
	endswitch;

?>
