<?php

/**
 * Show ENVironment INFO result from Admin Menu
 *
 * @module          env_info 
 * @author          Wolfgang Studer
 * @copyright       2014 Wolfgang Studer
 * @link            http://www.LEPTON-cms.org
 * @license         BSD License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1 2014-11-17
 */ 

// include class.secure.php to protect this file and the whole CMS!
if (defined('WB_PATH')) {	
	include(WB_PATH.'/framework/class.secure.php'); 
} else {
	$oneback = "../";
	$root = $oneback;
	$level = 1;
	while (($level < 10) && (!file_exists($root.'/framework/class.secure.php'))) {
		$root .= $oneback;
		$level += 1;
	}
	if (file_exists($root.'/framework/class.secure.php')) { 
		include($root.'/framework/class.secure.php'); 
	} else {
		trigger_error(sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR);
	}
}
// end include class.secure.php

/**
 *
 * AddOn: prepare output text tree
 *
 */

// function return result array
function outTEXT_TREE()
{
	global $envinfoArray;
	
	// get total level depth
	$array_depth = 0;
	array_depth( $envinfoArray, 1, $array_depth );
	$array_depth += 1;	// for last none-array element

	
	// start output
	echo '<div class="scrolling">' . PHP_EOL;
	echo '<pre>' . PHP_EOL;

	// fill with details
	outTEXT_TREE_detail( $envinfoArray, 1, $array_depth );
	
	// close 
	echo '</pre>' . PHP_EOL;
	echo '</div>' . PHP_EOL;

	// return
	return TRUE;
}

/**
 * following functions have been found at http://terrawebdesign.com/multidimensional.php
 * and has been manipulated and enhanced by myself to cover my needs
 */
 
// function to add number of empty cells in front of current cell
function outTEXT_TREE_offset( $level ) 
{
	$offset = "";             // offset for sub-array 
	for ($i=1; $i<$level;$i++):
		$offset = $offset . '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
	endfor;
	return $offset;
}

// function to build data cells
function outTEXT_TREE_detail( $array, $level, $array_depth ) {
	
	global $ENVINFOTEXT;
	
	if ( is_array($array) == TRUE ):			// check if input is an array
		foreach( $array as $key_val => $value ):
			// get level offset
			$offset = outTEXT_TREE_offset( $level );
			
			// get level detail
			if (is_array($value) == TRUE ):		// array is multidimensional
				echo $offset . $key_val . " :" . PHP_EOL;
				outTEXT_TREE_detail( $value, $level+1, $array_depth );
			else:								// (sub)array is not multidim
				echo $offset . $key_val . ' = ' . $value . PHP_EOL;
			endif;
       endforeach;
    else: // argument $array is not an array
        return;
    endif;
}



// return the select option
	$outItems["outTEXT_TREE"] = "TEXT_TREE";

// build GOTO list
	$gotoPrepare["outTEXT_TREE"] = FALSE;

// Add translation
	switch ( LANGUAGE):
	case "DE":
			$ENVINFOTEXT['TEXT_TREE'] = "TEXT TREE - Textbasierte Baumstruktur.";
			break;
	default:
			$ENVINFOTEXT['TEXT_TREE'] = "TEXT TREE - Text based Tree.";
	
	endswitch;

?>
