<?php

/**
 * Show ENVironment INFO result from Admin Menu
 *
 * @module          env_info 
 * @author          Wolfgang Studer
 * @copyright       2014 Wolfgang Studer
 * @link            http://www.LEPTON-cms.org
 * @license         BSD License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1 2014-11-17
 */ 

// include class.secure.php to protect this file and the whole CMS!
if (defined('WB_PATH')) {	
	include(WB_PATH.'/framework/class.secure.php'); 
} else {
	$oneback = "../";
	$root = $oneback;
	$level = 1;
	while (($level < 10) && (!file_exists($root.'/framework/class.secure.php'))) {
		$root .= $oneback;
		$level += 1;
	}
	if (file_exists($root.'/framework/class.secure.php')) { 
		include($root.'/framework/class.secure.php'); 
	} else {
		trigger_error(sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR);
	}
}
// end include class.secure.php


// debug
	$debug = true;

	if ( true === $debug ):
		ini_set('display_errors', 1);
		error_reporting(E_ALL|E_STRICT);
	endif;

	if ( !isset($admin) || !is_object($admin)) die();

// define module name
	$module_name = 'env_info';

// check if backend.css file needs to be included into the <body></body>
	if( ! method_exists($admin, 'register_backend_modfiles') && file_exists(WB_PATH .'/modules/' . $module_name . '/backend.css')) {
		echo '<style type="text/css">' . PHP_EOL;
		include( WB_PATH . '/modules/' . $module_name . '/backend.css');
		echo PHP_EOL . "</style>" . PHP_EOL;
	}

// get leptoken
	$leptoken = (isset($_GET['leptoken']) ? "?leptoken=".$_GET['leptoken'] : "" );

// check if module language file exists for the language set by the user (e.g. DE, EN); fallback = EN
	$lang = dirname(__FILE__)."/languages/".LANGUAGE.".php";
	include( file_exists($lang) ? $lang : dirname(__FILE__)."/languages/EN.php" );

// include function library
	include("lib_functions.php");
	
// initialize variables
	$envinfoArray = Array();		// data array prepared by info selection addons
	$infoItems = Array();			// array containing elements for INFO selection
	$outItems = Array();			// array containing elements for OUTPUT selection
	$gotoItems = Array();			// array containing elements for GOTO selection
	$gotoPrepare = Array();			// array containg info per output type if GOTO list should be build
	$envinfo_info = '';				// string containing requested info selection
	$envinfo_out = '';				// string containing requested output selection
	$selected = 'selected="selected" ';
	$envinfoHeader = '&nbsp;';		// header lines above generated output stream
	$envinfoHtml   = '&nbsp;';		// generated output stream shown
	$envinfoFooter = '&nbsp;';		// footer lines below generated output stream
	
// loop over all addons
	$handle = opendir( WB_PATH . '/modules/' . $module_name . '/addon/' );
	$i = 0;
	while ( FALSE !== ( $file = readdir($handle ))):
		$i++;
		if ( $i > 99 ):	// just to avoid endless loop in worst cases ...
			break;
		endif;
		
		if ( strtolower($file) == "index.php" ):
			continue;
		endif;
		
		$extension = strtolower(substr(strrchr($file, '.'), 1));
		if ( $extension <> 'php' ):
			continue;
		endif;
		
		// load the addon
		require_once( WB_PATH . '/modules/' . $module_name . '/addon/' . $file );
	endwhile;
	closedir($handle);
	
// sort infoItems for dropdown
	asort( $infoItems );
	
// generate output array
if (( isset($_POST['job']) ) && ($_POST['job'] == "save" )):

	$envinfo_info = $_POST['info_select'];
	$envinfo_out  = $_POST['out_select'];
	
	// set default output type when empty
	if ( empty($envinfo_out) == TRUE ):
		$envinfo_out = "outTABLE_TREE";
	endif;
	
	// load data into $envinfoArray
	$function = $envinfo_info;
	if ( function_exists( $function )):
		$envinfoArray = $function();
	endif;
	
// any data available ?
	if ( count( $envinfoArray ) > 0 ):
		// sort array alphabetically on root level
		ksort($envinfoArray);
	
		// sort second level by key
		reset($envinfoArray);
		while ( list( $rootkey, $dataArray ) = each( $envinfoArray ) ):
			if ( is_array($dataArray) == TRUE ):
				ksort($dataArray);
				$envinfoArray[$rootkey] = $dataArray;
			endif;
		endwhile;
	
		// build array with root level values
		if ( $gotoPrepare[$envinfo_out] == TRUE ):
			reset($envinfoArray);
			buildGoTo( $envinfoArray, 1 );
		endif;

		// generate output stream generic header
		$envinfoHeader = '  <br />
						  <h2>' . $ENVINFOTEXT[ $infoItems[ $envinfo_info ]] . '</h2>
							<br />
						  <h2>' . $ENVINFOTEXT[ $outItems[ $envinfo_out ]] . '</h2>
						  <hr />
							<br />';

		// generate output stream
		ob_start();
		reset($envinfoArray);
		$function = $envinfo_out;
		if ( function_exists( $function )):
			$function();
		endif;
		$envinfoHtml = ob_get_contents();
		ob_end_clean();

		// generate output stream generic footer
		$envinfoFooter = '  <br />
						  <hr />
							<br />
						  <a class="envinfo_anchor_TOP" title="' . $ENVINFOTEXT['GOTO_TOP'] . '" href="#TOP">&nbsp;&#238;&nbsp;&nbsp;' . $ENVINFOTEXT['GOTO_TOP'] .'</a>
							<hr />';

	else:
		// no data available
		$envinfoHtml = '<div class="nodata">' . $ENVINFOTEXT['NODATA'] . '</div>';
	endif;
	
else:
	// initial screen
		// set default output type when empty
		$envinfo_out = "outTABLE_TREE";

// end if select is set
endif;
?>

<a class="envinfo_anchor" id="TOP"></a>

<form id="envinfo_form" style="margin-top: 1em;" action="" method="post">
    <input type="hidden" name="job" value="save" />
	<table cellpadding="0" cellspacing="0" border="0" width="100%">
		<tr>
			<td><?php echo $ENVINFOTEXT['LABEL_INFO']; ?></td>
			<td colspan="3">
				<select name="info_select">
                	<option <?php ( empty($envinfo_info) == TRUE ? $selected : ''); ?> value=''><?php echo $ENVINFOTEXT['SELECT_INFO']; ?></option>
<?php 
	while ( list( $key, $value ) = each( $infoItems ) ):
       	echo '<option ' . ( $envinfo_info == $key ? $selected : '');
		echo ' value ="' . $key . '">';
		echo $ENVINFOTEXT[$value];
		echo '</option>' . PHP_EOL;
	endwhile;
?>
                </select>
			</td>
		</tr>
 
		<tr>
			<td><?php echo $ENVINFOTEXT['LABEL_OUT']; ?></td>
			<td colspan="3">
 				<select name="out_select">
                	<option <?php ( empty($envinfo_out) == TRUE ? $selected : ''); ?> value=''><?php echo $ENVINFOTEXT['SELECT_OUT']; ?></option>
<?php 
	while ( list( $key, $value ) = each( $outItems ) ):
       	echo '<option ' . ( $envinfo_out == $key ? 'selected="selected" ' : '');
		echo ' value ="' . $key . '">';
		echo $ENVINFOTEXT[$value];
		echo '</option>' . PHP_EOL;
	endwhile;
?>
                </select>
			</td>
		</tr>
       
 		<tr>
<?php
if ( count($gotoItems) > 0 ):
?>
			<td><?php echo $ENVINFOTEXT['LABEL_GOTO']; ?></td>
			<td colspan="3">
				<select name="goAnchor" onchange="javascript:window.location.hash=this.options[this.selectedIndex].value">
                	<option $selected value=''><?php echo $ENVINFOTEXT['SELECT_GOTO']; ?></option>
<?php
	while ( list( $key, $value ) = each( $gotoItems ) ):
        echo '		<option value ="' . $key . '">' . $value . '</option>' . PHP_EOL;
	endwhile;
?>
				</select>
			</td>
		</tr>
<?php
endif;	// if ( count($gotoItems) > 0 ):
?>
 		<tr>
			<td colspan="4">&nbsp;</td>
		</tr>
 		<tr>
			<td>&nbsp;</td>
			<td>
				<input type="submit" value="<?php echo $ENVINFOTEXT['SUBMIT']; ?>" />
            </td>
			<td>&nbsp;</td>
			<td>
                <input type="button" value="<?php echo $ENVINFOTEXT['CANCEL']; ?>" onclick="document.location='<?php echo ADMIN_URL; ?>/admintools/index.php<?php echo $leptoken; ?>';" />
            </td>
		</tr>
 		<tr>
			<td colspan="4">&nbsp;</td>
		</tr>
 		<tr>
			<td colspan="4"><hr /></td>
		</tr>
 		<tr>
			<td colspan="4"><?php echo $envinfoHeader; ?></td>
		</tr>
 		<tr>
			<td colspan="4"><?php echo $envinfoHtml; ?></td>
		</tr>
 		<tr>
			<td colspan="4"><?php echo $envinfoFooter; ?></td>
		</tr>
	</table>
</form>
